#!/usr/bin/perl

# Comment this next line out (put a # in front of it) if you don't 
# have CGI.pm installed on your server.  Most servers have it, so don't worry.
use CGI::Carp qw(fatalsToBrowser);

use LWP::Simple;

### Paths to required files:

require "ffs_config.cgi";
require "tigertom_lib.cgi";

      
##############################################################################
# COPYRIGHT NOTICE                                                           #
# TigerTom's Free-For-Some Link Trader Script. Version: 1.2, Jan. 2003.      # 
#                                                                            #  
# Copyright 2002 T. O' Donnell.  All Rights Reserved.                        #
# http://www.tigertom.com/contact.htm                                        #
#                                                                            #
# This Perl script may be used and modified by any purchaser so              # 
# long as this copyright notice and the comments below remain intact.        #
# It may only be used on domains owned by the purchaser.                     #                                                    
#                                                                            #
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'     # 
# Donnell from any liability that might arise from its use.                  #                                                                            #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.                                                       #
# You must get permission from T. O' Donnell and the other contributors      # 
# before redistributing this software over the Internet or via any           # 
# other medium.                                                              #
# You may not redistribute an altered version of this program in any form,   # 
# via any medium.                                                            # 
#                                                                            #
# In all cases copyright and header must remain intact.                      #
#                                                                            #                    
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United Kingdom Of Great Britain.                 #
#                                                                            #
##############################################################################

########### Form section layout

# You can alter this if you do so carefully. Note the commenting-out
# of quotation marks. Note the presence of important scalars (values beginning
# with $).

$form_html="

<BR><BR><HR><BR><FONT FACE=\"Verdana,Arial,Times New I2\" COLOR=\"#000000\" SIZE=\"2\"><B>Add your URL here.</B> You have to <B>link to 
$my_domain <I>first</I>.</B><BR>Please post links to web sites with 
content similar to this one.</FONT><BR><BR>

<table width=\"90%\" border=\"0\" cellspacing=\"3\" cellpadding=\"3\" align=\"left\">
<tr><td> 

<form method=\"post\" action=\"$cgi_url\">
<input type=\"text\" name=\"url\" value=\"http://\" size=\"30\" maxlength=\"200\">: Your web site URL.<BR> 
<input type=\"text\" name=\"text\" size=\"30\" maxlength=\"60\">: Text of your link.<BR> 
<input type=\"text\" name=\"reciprocal_link\" value=\"http://\" size=\"30\" maxlength=\"200\">: URL of reciprocal link to this site.<BR>
<input type=\"text\" name=\"email\" size=\"30\" maxlength=\"50\">: Your email address.<BR> 
<input type=\"submit\" value=\"Add URL\">
</form>

</td></tr>
</table>
<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>


";

############################### SETUP ENDS HERE ###################################

############# Sub routine order

&parse_data;
&output_links_page;
&check_method;
&check_referer;
&check_required;
&check_email;
&check_ip;
&set_scalars;
&check_content;
&check_for_valid_page;
&check_for_duplicates;
&check_reciprocal_link;
&get_date2;
&print_link;
&save_ip;
&email_trader;
&email_webmaster;
&end_url;
exit(0);


########################

sub output_links_page {

	if(!$buffer){

$file_name = $data_file;
&begin_acquire_file;
&close_file;
$html = "<HR><UL>\n";
foreach $line(@list) {
unless ($line eq "") {
@line = split(/\|/, $line);
unless ($line[0] !~ /\w+\.\w+/) {
$html = $html . "<LI><FONT SIZE=\"2\"><a href=\"$line[0]\">$line[1]</a></FONT></LI>\n";
		} # End unless
	} # End unless
   } # End foreach
$html = $html . "</UL>\n";

$message = $html . $form_html;
&output_page;
exit(0);
		} # End if			
	} # End sub


#################

sub set_scalars {

$url = "$FORM{'url'}";
$reciprocal_link = "$FORM{'reciprocal_link'}";
$text = "$FORM{'text'}";
$email = "$FORM{'email'}";
     }

###############

sub check_ip {

$file_name = "$ip_file";
&begin_acquire_file;
&close_file;

foreach $line(@list) {
if($line =~ $ENV{'REMOTE_ADDR'}) {

$title = "Error! You may not make more than one submission.";
$message = "Come back again another time.";

&output_page;
 
     } # End if
   } # End foreach
  } # End sub



#################

sub check_content {

# Check the length of the link text

if(length($text) > $max_link_text_length) {
$title = "Error! Text of your link is too long!";
$message = "You may enter no more than $max_link_text_length characters.";
&output_page; 
     }

# Get rid of non-alpha-numeric symbols
# to check for obscured bad words

$text_cleaned = $text;
$url_cleaned = $url;
$text_cleaned =~ s/\W//g;
$url_cleaned =~ s/\W//g;

foreach $word(@badwords) {

	if($text_cleaned =~ /$word/i || $url_cleaned =~ /$word/i) {

$title = "Error! Bad word in submitted data!";
$message = "Please submit sites with content similar to this one.";
&output_page;

			}
		} # End foreach
	} # End sub


########################

sub check_for_valid_page {

if($no_databases) {

if($reciprocal_link =~ /\?/) {

$title = "Error! Do not submit dynamically-generated reciprocal link pages.";
$message = "Links to databases will not be indexed by search engines.";

&output_page;
        
	} # End if
     } # End if
  } # End sub	

################

sub check_for_duplicates {

# Check that submitted link and reciprocal link are not same:
if($reciprocal_link eq $url) {

$title = "Warning: Submitted URL is the same as the reciprocal link";
$message = "

Please don't mess about on this web page. Thank you.

";

&output_page;

	} # End if

## Now check for duplicates in the database.

$url_root = $url;
&get_domain;


$file_name = "ffs_link.dat";
&begin_acquire_file;
&close_file;

foreach $line(@list) {
 if ($line =~ /$url_root/i) {
@linkz = split(/\|/, $line);

if ($linkz[0] =~ /$url_root/i) {

$title = "Error! Submitted domain <I>$url_root</I> already exists on this web page.";
$message = "You may not submit more than one link from that domain.";

&output_page;
		} # End if
	} # End if
   } # End foreach

# Check the submitted link is on the same domain as 
# the reciprocal link:

$their_domain = $url_root;
	
	# Get the domain the reciprocal link is on
	$url_root = $reciprocal_link;
	&get_domain;

# &debug;
# print "Their domain: $their_domain. URL root: $url_root.\n";
# exit;
	
if($url_root ne $their_domain) {
$title = "Warning: Poor quality or illicit reciprocal link!";
$message = "

The reciprocal link domain <B>$url_root</B> does not 
match your submitted link's domain <B>$their_domain.</B><BR><BR>
<I>These domains must match if you want to add your URL here.</I>

";

&output_page;

		} # End if


	} # End sub

#######################
sub check_reciprocal_link {

### Check they're not submitting a link on OUR site!

foreach $domain(@valid_urls) {
if ($reciprocal_link =~ /$domain/i) {
$title = "Naughty Naughty! Don't submit a page on THIS site as the reciprocal link.";
$message = "Put up a link on *your* site first.";

&output_page;

   } # End if
  } # End foreach

#### Check the reciprocal link exists

$content = get($reciprocal_link);
$content =~ s/\n//g;
$content =~ s/  //g;

if($content !~ /\<a href.+$my_domain.+/i) {

$title = "Error! There appears to be no link to $my_domain at the URL you've submitted.";
$message = "You must <I>first</I> put up a valid link to $my_domain.";

&output_page;

     } # End if

} # End sub

#################

sub print_link {

$file_name = "$data_file";
&begin_append_to_file;
print DATA "$url|$text|$reciprocal_link|$email\n";
&close_file;
   }

############
sub save_ip {

$file_name = "$ip_file";
&begin_write_to_file;
print DATA "$ENV{'REMOTE_ADDR'}";
&close_file;
   } # End sub

######

sub email_trader {

$recipient_name = "$email";
$recipient_email = "$email";
$subject = "Thank you for posting your link";

$email_message ="

URL: $url
Text: $text
At web page: $ENV{'HTTP_REFERER'}
Reciprocal link: $reciprocal_link


Please visit http://www.tigertom.com/orderin.html
and http://www.tigertom.com/perl-script.shtml to get
free software! Web master, you can insert your own
message here. Find the place where this text 
occurs in the script.

";

&send_email;

    } # End sub 

#########

sub email_webmaster {

$recipient_name = $sender_name;
$recipient_email = $sender_email;

$subject = "The following link has been posted...";

$email_message ="

$subject

URL: $url
Text: $text
At web page: $ENV{'HTTP_REFERER'}
Reciprocal link: $reciprocal_link
Posted by: $email

Cookies, if any: $ENV{'HTTP_COOKIE'}

";

&send_email;
# &call_mama;
    } # End sub 


# Get the root of the URL
sub get_domain {

# Get the root of the URL
$url_root =~ s/ //gi;
$url_root =~ s/http\:\/\///gi;
$url_root =~ s/www\.//gi;
$url_root =~ s/\/.+\.\w*htm\w*//gi;
$url_root =~ s/\/.+\.php\d*//gi;
$url_root =~ s/\/.+\.asp//gi;
$url_root =~ s/\/.+\.cgi//gi;
$url_root =~ s/\/.+\.pl//gi;
$url_root =~ s/\/.+\///gi;
$url_root =~ s/\?.+//gi;
$url_root =~ s/\///gi;
       } # End sub
